
event ClickAndDrag.OnMouseClick
{
	// Left button was clicked
	if (mouseButton == MB_LEFT)
	{
		// Start dragging
		self.$Drag = true;	
		
		// Save current object position
		self.$OrigPos = self.position;	
		
		// Save current mouse position
		self.$MousePos = GetMousePosition();
	}
}

event ClickAndDrag.OnUpdate
{
	if (self.$Drag == true)
	{
		// Calulate how far the mouse has moved
		Vector2 DeltaMove = GetMousePosition() - self.$MousePos.AsVector2();
		
		// Move object
		self.position = self.$OrigPos.AsVector2() + DeltaMove;
	}
}

event ClickAndDrag.OnMouseRelease
{
	// Left button was released
	if (mouseButton == MB_LEFT && self.$Drag == true)
	{
		// Stop dragging
		self.$Drag = false;
	}
}
